
#ifndef IMATH_HEADDER_INCLUDED
#define IMATH_HEADDER_INCLUDED

#include <sys/types.h>

#ifdef __WATCOMC__
typedef long fixed;
typedef unsigned long ufixed;

// Handy constants in fixed point
#define	IPI		0x3243F				// PI
#define	IRoot2	0x16A0A				// square root of 2
#define	IRoot3	0x1BB68				// cubic root of 2

fixed FPMUL( fixed, fixed );
/* ####.#### = ####.#### * ####.#### */
#pragma aux FPMUL = 						\
"	imul	edx								",\
"	add		eax, 0x8000						",\
"	mov		ax, dx							",\
"	rol		eax, 16							",\
	parm nomemory [eax] [edx]					\
	modify nomemory exact [eax edx] value [eax];
	
fixed FPUDIV( fixed, fixed );
/* ####.#### = ####.#### * ####.####	*/
#pragma aux FPUDIV =					\
"	mov		edx, eax						",\
"	shr		edx, 16							",\
"	shl		eax, 16							",\
"	div		ecx						",\
	parm nomemory [eax] [ecx] value [eax]	\
	modify exact nomemory [ eax ecx edx ];

fixed FPDIV( fixed, fixed );
/* ####.#### = ####.#### * ####.####	*/
#pragma aux FPDIV =					\
"	mov		edx, eax						",\
"	shr		edx, 16							",\
"	shl		eax, 16							",\
"	idiv		ecx						",\
	parm nomemory [eax] [ecx] value [eax]	\
	modify exact nomemory [ eax ecx edx ];
#else

#define FPMUL(a,b)   ((((unsigned long)a) >> 8) * (((unsigned long)b) >> 8))
#define FPDIV(a,b)   ((((unsigned long)a<<8) / ((unsigned long)b)) << 8)

#endif

#endif

